      subroutine doFba(a,b,natom,x,y,z,r,idtype,v,Fba,dFba)
!c234567
      use params
      use grad

      implicit none
      integer a,b,g,d,f,v,i,natom,idtype(natom),n,m
      double precision k(7),e,ee,eee,Rag,Rdb,Fba,dFba(natom,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),chi,dchi(natom,3)
      double precision lag(3),lbd(3),tmp,schi
      double precision el,em,en,elladmm,ellmimm,enn
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c k(4) is a submatrix of the overall kappa matrix in data_BA
!c234567
      d=min(idtype(a),idtype(b))
      f=max(idtype(a),idtype(b))
      do 12 g=1,4
         k(g)=parKappa(d,f,g,v)
 12   continue
      dFba=0.0
      dchi=0.0d0
      k(5)=k(3)-1.0
      k(6)=k(4)-1.0
      k(7)=k(1)*k(2)*k(3)*k(4)
c      write(*,*)'Kappa1=',k(1)

!c first check to see whether Fmb term has been deemed significant
      if(k(1).eq.(0.0d0))then
         Fba=1.0
	 flag(2)=.false.
      else !if k1.eq.0.0
       flag(2)=.true.
       chi=0.0d0
       do 10 g=1,natom
        if((g.ne.a).and.(g.ne.b))then
          do 11 d=1,natom
             if((d.ne.a).and.(d.ne.b))then
                Rag=r(a,g)
                Rdb=r(d,b)
                e=(Rag**k(3))+(Rdb**k(3))
                ee=dexp(-k(2)*e)
c		write(*,*)'e=',e,' ee=',ee,'Rag=',Rag,'Rbd=',Rdb
                chi=chi+ee
c       write(*,*)'Chi = ',chi
		if(dograd)then
                   do 20 n=1,natom
		      call lmndlm(a,g,natom,x,y,z,r)
		      if(a.eq.n)then
		         lag(1)=el
		         lag(2)=em
		         lag(3)=en
		      elseif(g.eq.n)then
		         lag(1)=-el
		         lag(2)=-em
		         lag(3)=-en
		      else
		         lag(1)=0.0d0
		         lag(2)=0.0d0
		         lag(3)=0.0d0
		      endif
		      call lmndlm(b,d,natom,x,y,z,r)
		      if(b.eq.n)then
		         lbd(1)=el
		         lbd(2)=em
		         lbd(3)=en
		      elseif(d.eq.n)then
		         lbd(1)=-el
		         lbd(2)=-em
		         lbd(3)=-en
		      else
		         lbd(1)=0.0d0
		         lbd(2)=0.0d0
		         lbd(3)=0.0d0
		      endif
		      do 13 m=1,3
c		         write(*,*)'m=',m,' lag=',lag(m),'lbd=',lbd(m)
                         eee=lag(m)*(Rag**k(5))
			 eee=eee+lbd(m)*(Rdb**k(5))
c			 write(*,*)'ee=',ee,' eee=',eee
                         dchi(n,m)=dchi(n,m)+ee*eee
 13                   continue
 20                continue
                endif
             endif !if d.ne.a and d.ne.b
 11       continue
        endif !if g.ne.a and g.ne.b
 10    continue

c       Fba=chi
c       do 111 n=1,natom
c       do 111 m=1,3
c           dFba(n,m)=-dchi(n,m)*k(2)*k(3)
c 111   continue
c       return
      
       chi=chi*k(1)
       e=dtanh(chi)
       Fba=1.0d0-(e**k(4))
       if(dograd)then
          ee=dexp(chi)
	  eee=1.0d0/ee
	  schi=2.0d0/(ee+eee)
	  schi=schi*schi
	  tmp=e**k(6)
	  tmp=tmp*k(7)*schi
          do 14 n=1,natom
          do 14 m=1,3
             dFba(n,m)=tmp*dchi(n,m)
 14       continue
       endif
      endif !if k1.eq.0.0
      end
